import { Component, OnInit, ViewChild } from '@angular/core';
import { ActivatedRoute, Router } from '@angular/router';
import { STColumn, STComponent, STData } from '@delon/abc/st';
import { SFComponent, SFDateWidgetSchema, SFSchema, SFSchemaEnum, SFSelectWidgetSchema, SFUISchema } from '@delon/form';
import { ShipperBaseService } from '@shared';
import { NzModalService } from 'ng-zorro-antd/modal';
import { of } from 'rxjs';
import { map } from 'rxjs/operators';
import { TaxManagementService } from '../../services/tax-management.service';
// import { DatatableReportingUploadSettingComponent } from '../upload-setting/upload-setting.component';
// import { DatatableReportingVerifyResultComponent } from '../verify-result/verify-result.component';

@Component({
  selector: 'app-tax-management-individual-declare',
  templateUrl: './individual-declare.component.html',
  styleUrls: ['./individual-declare.component.less']
})
export class TaxManagementIndividualDeclareComponent implements OnInit {
  _$expand = false;
  ui!: SFUISchema;
  schema!: SFSchema;
  columns!: STColumn[];
  @ViewChild('st', { static: false }) st!: STComponent;
  @ViewChild('sf', { static: false }) sf!: SFComponent;
  tabType!: string;
  tabs: any[] = [
    { name: '待申报', value: '0' },
    { name: '待审核', value: '1' },
    { name: '已通过', value: '2' },
    { name: '不通过', value: '3' },
    { name: '全部', value: '' }
  ];
  selectedIndex = ''; //选择的项目
  serviceTel = '';
  isVisible: boolean = false;
  constructor(
    public service: TaxManagementService,
    private router: Router,
    private ar: ActivatedRoute,
    public shipperservice: ShipperBaseService,
    private modal: NzModalService,
    public shipperSrv: ShipperBaseService
  ) {}

  /**
   * 查询字段个数
   */
  get queryFieldCount(): number {
    return Object.keys(this.schema?.properties || {}).length;
  }

  /**
   * 查询参数
   */
  get reqParams() {
    console.log();

    const params = Object.assign({}, this.sf?.value || {});
    if (this.selectedIndex) {
      params.declareStatus = this.selectedIndex;
    }
    delete params._$expand;
    return { ...params };
  }

  /**
   * 选中行
   */
  get selectedRows() {
    return this.st?.list.filter((item: any) => item.checked) || [];
  }

  /**
   * 伸缩查询条件
   */
  expandToggle() {
    this._$expand = !this._$expand;
    this.sf?.setValue('/_$expand', this._$expand);
  }

  /**
   * 重置表单
   */
  resetSF() {
    this.sf.reset();
    this._$expand = false;
  }
  /**
   * 程序初始化入口
   */
  ngOnInit() {
    this.initSF();
    this.initST();
    const object1: any = {};
    const object2: any = {};
    Object.defineProperty(object1, 'name', { writable: false, value: 'wang' });
    Object.defineProperty(object2, 'xxoo', { writable: false, value: 'wang' });
    console.log(object1);
    console.log(object1.name);
    console.log(object2);
    console.log(object2.xxoo);
    object1.name = 'ming';
    object2.xxoo = 'ming';
    console.log(object1);
    console.log(object2);
  }

  /**
   * 初始化查询表单
   */
  initSF() {
    this.schema = {
      properties: {
        _$expand: { type: 'boolean', ui: { hidden: true } },
        driverName: { title: '司机姓名', type: 'string', ui: { placeholder: '请输入' } },
        telephone: {
          type: 'string',
          title: '联系电话',
          ui: {
            placeholder: '请输入'
          }
        },
        cardNumber: {
          title: '证件号码',
          type: 'string',
          ui: {
            placeholder: '请输入证件号码'
          }
        },
        declareStatus: {
          title: '申报状态',
          type: 'string',
          ui: {
            placeholder: '请选择',
            widget: 'dict-select',
            params: { dictKey: 'taxincome:declare:status' },
            containsAllLabel: true,
            visibleIf: {
              _$expand: (value: boolean) => value
            }
          }
        },
      
        isOvertime: {
          title: '是否逾期',
          type: 'string',
          enum: [
            { value: '', label: '全部' },
            { value: false, label: '否' },
            { value: true, label: '是' }
          ],
          ui: {
            placeholder: '请选择',
            widget: 'select',
            containsAllLabel: true,
            visibleIf: {
              _$expand: (value: boolean) => value
            }
          },
          default: ''
        },
        taxDate: {
          title: '税款所属期',
          type: 'string',
          ui: {
            widget: 'sl-from-to',
            type: 'date',
            format: 'yyyy-MM-dd',
            visibleIf: {
              _$expand: (value: boolean) => value
            }
          } as SFDateWidgetSchema
        },
        declareDate: {
          title: '申报日期',
          type: 'string',
          ui: {
            widget: 'sl-from-to',
            type: 'date',
            format: 'yyyy-MM-dd',
            visibleIf: {
              _$expand: (value: boolean) => value
            }
          } as SFDateWidgetSchema
        },
        ltdId: {
          type: 'string',
          title: '网络货运人',
          ui: {
            widget: 'select',
            placeholder: '请选择',
            allowClear: true,
            visibleIf: {
              _$expand: (value: boolean) => value
            },
            asyncData: () => this.shipperservice.getNetworkFreightForwarder()
          }
        }
      }
    };
    this.ui = {
      '*': { spanLabelFixed: 120, grid: { span: 8, gutter: 4 }, enter: () => this.search() },
      $time: { grid: { span: 24 } }
    };
  }

  /**
   * 初始化数据列表
   */
  initST() {
    this.columns = [
      { title: '', type: 'checkbox', className: 'text-center', width: '60px' },
      {
        title: '申报状态',
        index: 'declareStatus',
        className: 'text-center',
        width: '120px',
        type: 'badge',
        badge: {
          '0': { text: '待申报', color: 'default' },
          '1': { text: '待审核', color: 'processing' },
          '2': { text: '已通过', color: 'success' },
          '3': { text: '不通过', color: 'error' }
        }
      },
      {
        title: '是否逾期',
        index: 'overdueStatus',
        className: 'text-center',
        width: '120px',
        type: 'enum',
        enum: { false: '否', true: '是' }
      },
      {
        title: '税款所属期起',
        index: 'skssqq',
        className: 'text-center',
        width: '150px'
      },
      { title: '税款所属期止', index: 'skssqz', className: 'text-center', width: '150px' },
      {
        title: '纳税人名称',
        index: 'nsrmc',
        className: 'text-center',
        width: '180px'
      },
      { title: '纳税人识别号', index: 'nsrsbh', className: 'text-center', width: '200px' },
      { title: '姓名', index: 'xm', className: 'text-center', width: '200px' },
      { title: '证件类型', index: 'sfzjlx', className: 'text-center', width: '200px' },
      { title: '证件号码', index: 'sfzjhm', className: 'text-center', width: '200px' },
      { title: '联系电话', index: 'lxdh', className: 'text-center', width: '200px' },
      { title: '国家（地区）', index: ' gjdq', className: 'text-center', width: '200px' },
      { title: '所属行业', index: 'hy', className: 'text-center', width: '200px' },
      { title: '征收项目', index: 'zsxm', className: 'text-center', width: '200px' },
      { title: '征收品目', index: 'zsmp', className: 'text-center', width: '200px' },
      {
        title: '计税依据',
        index: 'jsyj',
        className: 'text-center',
        width: '200px',
        type: 'widget',
        widget: { type: 'currency-chy', params: ({ record }) => ({ value: record.ynse }) }
      },
      {
        title: '税率',
        index: 'sl',
        render: 'sl',
        className: 'text-center',
        width: '200px',
        format: item => `${item.sl ? ((item.sl as number) * 100).toFixed(2) : 0}%`
      },
      {
        title: '应纳税额',
        index: 'ynse',
        className: 'text-center',
        width: '180px',
        type: 'widget',
        widget: { type: 'currency-chy', params: ({ record }) => ({ value: record.ynse }) }
      },
      {
        title: '减免税额',
        index: 'jmse',
        className: 'text-center',
        width: '180px',
        type: 'widget',
        widget: { type: 'currency-chy', params: ({ record }) => ({ value: record.jmse }) }
      },
      {
        title: '已缴纳税额',
        index: 'yjnse',
        className: 'text-center',
        width: '180px',
        type: 'widget',
        widget: { type: 'currency-chy', params: ({ record }) => ({ value: record.yjnse }) }
      },
      {
        title: '应代征税额',
        index: 'dzse',
        className: 'text-center',
        width: '180px',
        type: 'widget',
        widget: { type: 'currency-chy', params: ({ record }) => ({ value: record.dzse }) }
      },
      {
        title: '已代征税额',
        index: 'ydzse',
        className: 'text-center',
        width: '150px',
        type: 'widget',
        widget: { type: 'currency-chy', params: ({ record }) => ({ value: record.ydzse }) }
      },
      { title: '申报日期', render: 'sbrq', className: 'text-center', width: '150px' }
    ];
  }

  /**
   *更正
   * @param record 记录实例
   */
  recall() {
    if (this.selectedRows.length === 0) {
      this.openWainingModal('请选择需要更正的数据');
      return;
    }
    // this.modal.confirm({
    //   nzTitle: '撤回提示',
    //   nzContent: ' 撤回后可以重新上传，重新上传会覆盖已上传数据，确定要撤回？',
    //   nzOkText: '确定',
    //   nzCancelText: '取消',
    //   nzOnOk: () => {
    //     this.service.request(this.service.$api_recall_reporting, { rows: this.selectedRows }).subscribe((res: any) => {
    //       if (res) {
    //         this.service.msgSrv.success('撤销成功');
    //         this.search();
    //       }
    //     });
    //   }
    // });
  }
  /**
   *修改
   * @param record 记录实例
   */
  uploadSetting() {
    if (this.selectedRows.length === 0) {
      this.openWainingModal('请选择需要修改的数据！');
      return;
    }
    // this.isVisible = true
  }
  /**
   *撤销
   * @param record 记录实例
   */
  unnormal(value: any) {
    this.modal.confirm({
      nzTitle: '税务审核结果',
      nzContent: '订单结算时间所在月份与申报月份不一致',
      nzOkText: '确定',
      nzCancelText: '',
      nzOnOk: () => {
        this.service.request(this.service.$api_recall_reporting, { rows: this.selectedRows }).subscribe((res: any) => {
          if (res) {
            this.service.msgSrv.success('撤销成功');
            this.search();
          }
        });
      }
    });
  }

  selectChange(item: any) {
    this.selectedIndex = item?.value || '';
    setTimeout(() => {
      this.st.load(1);
    });
  }

  /**
   * 查看当行数据
   */
  view(record: STData) {
    // this.router.navigate(['../view', record.uuid], { relativeTo: this.ar });
    this.router.navigate(['../detail'], {
      queryParams: {
        id: record.id
      },
      relativeTo: this.ar
    });
  }

  // appeal(item: any) {
  //   const modalRef = this.modal.create({
  //     nzTitle: '申诉',
  //     nzWidth: '40%',
  //     nzContent: CtcAppealComponent,
  //     nzComponentParams: {
  //       i: item,
  //       status: 'add'
  //     },
  //     nzFooter: null
  //   });
  //   modalRef.afterClose.subscribe(res => {
  //     if (res) {
  //       this.search({ representationsStatus: '' });
  //     }
  //   })
  // }

  /**
   * 申报
   */
  upload() {
    if (this.selectedRows.length === 0) {
      this.openWainingModal('请选择需要申报的数据');
      return;
    }
    // this.service.request(this.service.$api_recall_reporting, { rows: this.selectedRows }).subscribe((res: any) => {
    //   if (res) {
    //     this.service.msgSrv.success('申报成功');
    //     this.search();
    //   }
    // })
  }

  /**
   *
   * @param params 更新数据
   */
  resetData() {
    if (this.selectedRows.length === 0) {
      this.openWainingModal('请选择需要更新的数据');
      return;
    }
    let params: any[] = [];
    this.selectedRows.forEach(item => {
      params.push(item.id);
    });
    this.service.request(this.service.$api_get_taxDeclaration_updateAll, params).subscribe((res: any) => {
      if (res) {
        this.service.msgSrv.success('更新成功');
        this.st.load(1);
      }
    });
  }

  /**
   * 查看校验结果
   */
  viewResult(item: any) {
    // const modalRef = this.modal.create({
    //   nzTitle: '本地校验结果',
    //   nzWidth: 1200,
    //   nzContent: TaxManagementOrderVerifyResultComponent,
    //   nzComponentParams: {
    //     record: item
    //   },
    //   nzFooter: null
    // });
    // modalRef.afterClose.subscribe(res => {
    // })
  }

  /**
   * 查看监管审核结果
   */
  viewAuditResult(record: any) {
    if (record?.billStatus !== '2') {
      return;
    }
    this.openWainingModal('监管审核结果', record?.result);
  }

  search() {
    this.st.load(1);
  }

  /**
   * 异步导出
   */
  export() {
    this.service.exportStart(this.sf?.value, this.service.$api_async_export_order_reporting_list);
  }

  openWainingModal(content: string, title = '提示') {
    this.modal.warning({
      nzMask: false,
      nzTitle: title,
      nzContent: content
    });
  }
  handleOK() {}
  handleCancel() {
    this.isVisible = false;
  }
}
